//#define ALLOW_ACCESS_TO_INTERNALS_OF_LISTS
#include <PalmOS.h>

#include "StarterRsc.h"

#include "mylib.h"

UInt16 mySysTicksPerSecond=SysTicksPerSecond();
CFidoDBList cfdl ;

CArea area;
SAreaHeader sah; //  
SMessage message; // 
char area_status,msg_status;

CMessageViewer cmv;

UInt16 lastpenx,lastpeny,tmp_value;

char StatusFieldText[40],area_stat[40],date_hdr[32],last_search_string[64];
UInt32 last_key_status=0;
UInt32 curromVersion;

FontPtr fontp=NULL;
LocalID fontdbid=0;
MemHandle fonth=0;
DmOpenRef fontdbref;

char zerostring[1]={0};

SPreferenceType FidoReaderPrefs;

#define appFileCreator				 'GaUs'
#define appVersionNum              0x00
#define appPrefID                  0x00
#define appPrefVersionNum          0x05

#define KEY_ALL_ENABLE				0xFFFFFFFFu
#define KEY_NEED_ENABLE				(~(0xFFFFFFFFu&(8|16|32|64)))

#define ourMinVersion	sysMakeROMVersion(3,1,0,sysROMStageRelease,0)
#define palmos35Version	sysMakeROMVersion(3,5,0,sysROMStageRelease,0)

static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
	UInt32 gromVersion;
	
	FtrGet(sysFtrCreator,sysFtrNumROMVersion,&gromVersion);
	if(gromVersion<requiredVersion)
	{
		if((launchFlags&(sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp))==(sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp))
		{
			FrmAlert (RomIncompatibleAlert);
			if(gromVersion<ourMinVersion)
				AppLaunchWithCommand(sysFileCDefaultApp, sysAppLaunchCmdNormalLaunch, NULL);
		}
		return sysErrRomIncompatible;
	}
//	curromVersion=gromVersion;
	return errNone;
};

void FillMsgHead()
{
	if(area_status && msg_status)
	{
		SetFieldText(MsgHeaderFromField,message.from);
		SetFieldText(MsgHeaderToField,message.to);
		SetFieldMLText(MsgHeaderSubjField,message.subj);
		SetFieldText(MsgHeaderAddrField,message.addr);
		SetFieldText(MsgHeaderAreaField,message.area);
		mlSecondsToStrData(date_hdr,message.datetime);
		SetFieldText(MsgHeaderDataField,date_hdr);
	}
	else
	{
		SetFieldText(MsgHeaderFromField,zerostring);
		SetFieldText(MsgHeaderToField,zerostring);
		SetFieldMLText(MsgHeaderSubjField,zerostring);
		SetFieldText(MsgHeaderAddrField,zerostring);
		SetFieldText(MsgHeaderAreaField,zerostring);
		SetFieldText(MsgHeaderDataField,zerostring);
	}
}

void DisplayMessage()
{
	FormType* formP;
	formP=FrmGetActiveForm();
	
	FontID selfont;

	mlEraseRectangle(0,0,79,11);
	mlEraseRectangle(81,0,80,11);
	mlEraseRectangle(0,13,159,11);
	
	mlDrawBitmap(62,149,bmpnaBitmap);
	
	if(area_status && msg_status)
	{
		StrPrintF(area_stat,"%d of %d",area.GetCurrentIndex()+1,area.GetCount());
		
//		FntSetFont((FontID)stdFont);
		
		WinDrawTruncChars(message.from,StrLen(message.from),0,0,79);
		WinDrawTruncChars(message.to,StrLen(message.to),82,0,79);
		WinDrawTruncChars(message.subj,StrLen(message.subj),0,13,159);
		
		if((FontID)FidoReaderPrefs.CurrentFontID==(FontID)130)
		{
			if(fonth)
				selfont=(FontID)130;
			else
				selfont=stdFont;
		}
		else
			selfont=(FontID)FidoReaderPrefs.CurrentFontID;

		cmv.Free();
		cmv.Init(message.text,0,25,159,121,selfont);
		cmv.Show();
		
		if(message.attributes&FIDO_MSG_ATTR_READ)
			mlDrawBitmap(62,149,bmpattrreadBitmap);
		else
			mlDrawBitmap(62,149,bmpattrunreadBitmap);
	
	}
	else
	{
		mlEraseRectangle(0,25,159,121);
		StrPrintF(area_stat,"no msg");
		mlDrawBitmap(62,149,bmpnaBitmap);
	}
	
	WinDrawGrayLine(80,0,80,11);
	WinDrawGrayLine(0,12,159,12);
	
	WinDrawGrayLine(0,23,159,23);
	WinDrawLine(0,24,159,24);
	WinDrawLine(0,147,159,147);
	WinDrawGrayLine(0,148,159,148);

	mlEraseRectangle(12,149,44,11);
//	FntSetFont(boldFont);	
	WinDrawChars(area_stat,StrLen(area_stat),12+25-(FntCharsWidth(area_stat,StrLen(area_stat))>>1),149);
}


void DisplayCurrentMessage()
{
	if(area_status)
	{
		if(msg_status)
			delete[] message.area;
		
		msg_status=0;
		
		if(area.GetCurrentMessage(&message))
		{
			msg_status=1;
			area.SetMessageAttribute(area.GetCurrentIndex(),1,FIDO_MSG_ATTR_READ);
		};

		DisplayMessage();
	};
};

char OpenAreaForRead(int area_index)
{
	if(area_status && msg_status)
		return 0;
		
	if(area_index<0 || area_index>cfdl.GetAreaCount())
		return 0;
		
	LocalID areadbid;
	
	areadbid=cfdl.GetLocalID(area_index);
	
	if(!areadbid)
		return 0;
		
	if(!area.Open(areadbid))
		return 0;
		
	area_status=1;
	msg_status=0;
	return 1;
}

void SaveAndCloseArea()
{
	if(area_status)
	{
		area.Close();
		area_status=0;
	};
	
	if(msg_status)
	{
		delete[]message.area;
		msg_status=0;
	};
}

void RefreshAreaList()
{
	cfdl.Init();
	cfdl.ToList((ListType*)GetObjectPtr(MainArea_listList));
	if(FidoReaderPrefs.SelectedArea<cfdl.GetAreaCount())
		LstSetSelection((ListType*)GetObjectPtr(MainArea_listList),FidoReaderPrefs.SelectedArea);
	StrPrintF(StatusFieldText,": %d(%dk)",cfdl.GetAreaCount(),cfdl.GetAllAreaSize());
	SetFieldText(MainStatusField,StatusFieldText);
};

static void MainFormInit(FormPtr /*frmP*/)
{

}

static Boolean MainFormDoCommand(UInt16 command)
{
	Boolean handled=false;
	
	char buf[40];
	
	switch(command)
	{
	case AreaDBClean:
		if(cfdl.GetAreaCount())
			if(FrmAlert(QCleanAreaAlert)==QCleanAreaOK)
				if(FidoReaderPrefs.SelectedArea>=0 && FidoReaderPrefs.SelectedArea<cfdl.GetAreaCount())
				{
					area.DeleteAllMessages(cfdl.GetLocalID(FidoReaderPrefs.SelectedArea),1);
					RefreshAreaList();
				}
	
		break;
		
	case TosserPurge:
		DoPurge();
		RefreshAreaList();
		break;
		
	case AreaDBPrefs:
		if(cfdl.GetAreaCount())
			FrmPopupForm(AreaPrefsForm);
		break;
		
	case AreaDBCreate:
	
		if(curromVersion<palmos35Version)
		{
			StrCopy(buf,"-[NEW_AREA_NAME]-");
	
			if(mlGetString(buf,40,"  "," ",1))
			{
				if(!area_status)
				{
					area.Create(buf);
					area.Close();
					RefreshAreaList();
				}
			}
		}
		else
		{
			if(FrmCustomResponseAlert(GetAreaNameAlert,NULL,NULL,NULL,buf,30,NULL)==0)
			{
				if(!area_status)
				{
					area.Create(buf);
					area.Close();
					RefreshAreaList();
				}
			}
		}
		break;
	case HelpHowtouse:
		FrmHelp(hlpHowUseString);
		break;
		
	case HelpAbout:
		FrmAlert(AboutAlert);
		break;

	case TosserSetup:
		FrmPopupForm(TosserCFGForm);
		break;

	case AreaDBDelete:
		if(FidoReaderPrefs.SelectedArea>=0 && FidoReaderPrefs.SelectedArea<cfdl.GetAreaCount())
		{
			if(FrmAlert(QDeleteAreaAlert)==0)
			{
				DmDeleteDatabase(0,cfdl.GetLocalID(FidoReaderPrefs.SelectedArea));
				RefreshAreaList();
			};
		};
		break;

	case AreaDBDeleteALL:
		if(cfdl.GetAreaCount())
		{
			if(FrmAlert(QDeleteAllAlert)==0)
			{
				for(int i=0;i<cfdl.GetAreaCount();i++)
					DmDeleteDatabase(0,cfdl.GetLocalID(i));
				RefreshAreaList();
			};
		};
		break;
	
	case AreaDBOpen:
		if(FidoReaderPrefs.SelectedArea>=0 && FidoReaderPrefs.SelectedArea<cfdl.GetAreaCount())
			FrmGotoForm(MsgForm);
	
		break;

	case TosserRun:
		DoToss(0);
		RefreshAreaList();
		break;

	case TosserClean:
		DoClean();
		RefreshAreaList();
		break;
	}
	
	handled=true;
	
	return handled;
}


static void MsgFormInit(FormPtr /*frmP*/)
{
	area_status=0;
	msg_status=0;
}

static Boolean MainFormHandleEvent(EventPtr eventP)
{
   Boolean handled=false;
   FormPtr frmP;

	switch (eventP->eType) 
	{
		
	case keyDownEvent:
		
		ListType* lst;
		lst=(ListType*)GetObjectPtr(MainArea_listList);

		if(eventP->data.keyDown.chr==12) //
		{
			if(FidoReaderPrefs.SelectedArea<cfdl.GetAreaCount()-1)
				LstSetSelection((ListType*)GetObjectPtr(MainArea_listList),++FidoReaderPrefs.SelectedArea);
//			LstScrollList(lst,winDown,1);
		}

		if(eventP->data.keyDown.chr==11) //
		{
			if(FidoReaderPrefs.SelectedArea>0 && cfdl.GetAreaCount())
				LstSetSelection((ListType*)GetObjectPtr(MainArea_listList),--FidoReaderPrefs.SelectedArea);
//			LstScrollList(lst,winUp,1);
		}
		
		if(last_key_status==64)
			if(FidoReaderPrefs.SelectedArea>=0 && FidoReaderPrefs.SelectedArea<cfdl.GetAreaCount())
				FrmGotoForm(MsgForm);

		handled=true;
		
		break;
		
	case lstSelectEvent:
		if(eventP->data.lstSelect.listID==MainArea_listList)
		{
			FidoReaderPrefs.SelectedArea=eventP->data.lstSelect.selection;
			if(eventP->screenX<105)
				FrmGotoForm(MsgForm);
			if(eventP->screenX>130)
				if(cfdl.GetAreaCount())
					FrmPopupForm(AreaPrefsForm);
		};
	
		handled=true;
		break;
	case menuEvent:
		return MainFormDoCommand(eventP->data.menu.itemID);

	case frmOpenEvent:
		frmP=FrmGetActiveForm();
		MainFormInit(frmP);
		FrmDrawForm(frmP);
		RefreshAreaList();
		handled=true;
		break;

	default:
		break;
	}
	
	return handled;
}

static Boolean MsgFormDoCommand(UInt16 command)
{
	Boolean handled=false;
//   FormPtr frmP;

	switch(command)
	{
	case ToolsSearch:
		if(area_status && msg_status)
		{
			UInt16 fi;
			fi=0xFFFF;
			
			switch(mlGetSearchString(last_search_string))
			{
			case SEARCH_START:
				fi=area.Search(last_search_string);
				break;
				
			case SEARCH_CONTINUE:
				fi=area.Search(last_search_string,area.GetCurrentIndex()+1);
				break;
			}

			if(fi!=0xFFFF)
				if(area.MoveTo(fi))
					DisplayCurrentMessage();
		}
		handled=true;
		break;
		
	case ToolsMessagetoMemoPad:
		if(area_status && msg_status)
		{
			UInt16 size;
			
			size=FIDO_MAX_DATA_LEN+FIDO_MAX_AREA_NAME_LEN+FIDO_MAX_NAME_LEN*2+FIDO_MAX_SUBJ_LEN+StrLen(message.text)+1024;
			
			char *buf,tbuf[64];
			buf=new char [size];
			if(buf)
			{
				MemSet(buf,size,0);
				
				mlSecondsToStrData(tbuf,message.datetime);
				StrPrintF(buf,"- %s %s -\n from: %s (%s)\n to: %s\n subj: %s\n----\n%s",message.area,tbuf,message.from,message.addr,message.to,message.subj,message.text);

				if(mlNewRecordInMemoPad(buf))
					FrmAlert(MsgCopyOKAlert);
				delete[]buf;
			}
		}
		break;

	case ToolsSelectedtoMemoPad:
/*
		if(area_status && msg_status)
		{
			UInt16 start_pos,end_pos,size;
//			FldGetSelection((FieldType*)GetObjectPtr(MsgTextField),&start_pos,&end_pos);
			
			size=end_pos-start_pos;
			
			if(size)
			{
				char *buf;
				size++;
				buf=new char [size];
				if(buf)
				{
					MemSet(buf,size,0);
					MemMove(buf,message.text+start_pos,size-1);
					
					if(mlNewRecordInMemoPad(buf))
						FrmAlert(SelectedCopyOkAlert);
						
					delete[] buf;
				}
			}
		}
*/
		break;
		
	case ToolsSelectfont:
				
		FontID newFontID;
		LocalID oldid=FidoReaderPrefs.fontdbid;
		
		newFontID=mlFontSelect((FontID)FidoReaderPrefs.CurrentFontID);

		if(newFontID!=(FontID)FidoReaderPrefs.CurrentFontID && FidoReaderPrefs.fontdbid==oldid)
		{
			FidoReaderPrefs.CurrentFontID=(UInt8)newFontID;
			DisplayCurrentMessage();
			break;
		}
		
		if(FidoReaderPrefs.fontdbid!=oldid)
		{
			if(fonth)
			{
				MemHandleUnlock(fonth);
				fonth=0;
				DmReleaseRecord(fontdbref,0,true);	
				DmCloseDatabase(fontdbref);
			}
	
			fontdbref=DmOpenDatabase(0,FidoReaderPrefs.fontdbid,dmModeReadOnly);
			fonth=DmGetRecord(fontdbref,0);
			fontp=(FontPtr)MemHandleLock(fonth);
			
			if(FntDefineFont((FontID)130,fontp)==0)
				FidoReaderPrefs.CurrentFontID=(UInt8)newFontID;
			else
			{
				MemHandleUnlock(fonth);
				fonth=0;
				DmReleaseRecord(fontdbref,0,true);	
				DmCloseDatabase(fontdbref);
			}
			DisplayCurrentMessage();
			break;
		}

		break;
	case ToolsCopytoarea:
		if(area_status && msg_status)
		{
			LocalID sdb;
			CArea *tArea;
			
			sdb=cfdl.SelectDB();
			if(sdb)
			{
				if(sdb!=cfdl.GetLocalID(FidoReaderPrefs.SelectedArea))
				{
					tArea=new CArea();
					if(tArea)
					{
						tArea->Open(sdb);
						tArea->AddMessage(&message);
						tArea->Close();
						delete tArea;
					
						cfdl.Init();
					}
				}
				else
					FrmAlert(ErrCopyAlert);
			}
		}
		
		break;

	case GoToBytree:
		if(area_status)
			if(area.MoveByTree())
				DisplayCurrentMessage();
		break;

	case GoToFirst:
		if(area_status)
			if(area.MoveToFirst())
				DisplayCurrentMessage();
		break;

	case GoToFirstunread:
		if(area_status)
			if(area.MoveToFirstUnread())
				DisplayCurrentMessage();
		break;

	case GoToNextunread:
		if(area_status)
			if(area.MoveToNextUnread())
				DisplayCurrentMessage();
		break;

	case GoToLast:
		if(area_status)
			if(area.MoveToLast())
				DisplayCurrentMessage();
		break;
	}
//	handled=true;
	
	return handled;
}

static Boolean MsgFormHandleEvent(EventPtr eventP)
{
   Boolean handled=false;
   FormPtr frmP;
	UInt16 total_msg,current_msg,goto_result;
	
	switch (eventP->eType) 
	{
	case penDownEvent:
		if(eventP->screenY<22)
			FrmPopupForm(MsgHeaderForm);
			
		if(eventP->screenX>150)
			if(cmv.ScrollByBar(eventP->screenY))
				cmv.Show();
				
		break;

	case penUpEvent:
	case penMoveEvent:

		if(eventP->screenX>150)
			if(cmv.ScrollByBar(eventP->screenY))
				cmv.Show();
				
		break;

	case sclExitEvent:
	case sclRepeatEvent:
		break;

	case fldChangedEvent:
		break;
	
	case keyDownEvent:

		switch(eventP->data.keyDown.chr)
		{
		case 's':
		case 'S':
		case '':
		case '':
			MsgFormDoCommand(ToolsSearch);
		
			break;
			
		case 'l':
		case 'L':
		case '':
		case '':

		case 'i':
		case 'I':
		case '':
		case '':

			if(area_status)
				if(area.MoveByList())
					DisplayCurrentMessage();
			break;

		}

		switch(last_key_status)
		{
		case 8:
			if(area_status)
				if(area.DeleteCurrentMessage())
					DisplayCurrentMessage();
			break;
		case 16:
			if(area_status)
				if(area.MoveToPrev())
					DisplayCurrentMessage();
			break;
		case 32:
			if(area_status)
				if(area.MoveToNext())
					DisplayCurrentMessage();
			break;
		case 64:
			FrmGotoForm(MainForm);
			break;
		}
	
		last_key_status=0;

		if(eventP->data.keyDown.chr==12)
		{
			if(cmv.PageDown())
				cmv.Show();
			else
			{
				if(area_status)
					if(area.MoveToNext())
						DisplayCurrentMessage();
			}
		}
	
		if(eventP->data.keyDown.chr==11)
		{
			if(cmv.PageUp())
				cmv.Show();
			else
			{
				if(area_status)
					if(area.MoveToPrev())
						DisplayCurrentMessage();
			}
		}
	
		handled=true;
		
		break;
	
	case menuEvent:
		return MsgFormDoCommand(eventP->data.menu.itemID);
		
	case frmCloseEvent:
		SaveAndCloseArea();
		handled=false;
		break;

	case frmOpenEvent:
		frmP=FrmGetActiveForm();
		MsgFormInit(frmP);
		FrmDrawForm(frmP);
		OpenAreaForRead(FidoReaderPrefs.SelectedArea);
		DisplayCurrentMessage();
		
		handled=true;
		break;
		
	case ctlSelectEvent:
		switch(eventP->data.ctlSelect.controlID)
		{
		
		case MsgBtGoToMsgButton:
			total_msg=area.GetCount();
			current_msg=area.GetCurrentIndex();
			goto_result=mlGetGoToCommand(total_msg,current_msg);
		
			switch(goto_result)
			{
			case GOTO_FIRST:
				handled=MsgFormDoCommand(GoToFirst);
				break;

			case GOTO_LAST:
				handled=MsgFormDoCommand(GoToLast);
				break;

			case GOTO_FIRST_UNREAD:
				handled=MsgFormDoCommand(GoToFirstunread);
				break;

			case GOTO_NEXT_UNREAD:
				handled=MsgFormDoCommand(GoToNextunread);
				break;

			case GOTO_YES:
				if(area.MoveTo(current_msg))
					DisplayCurrentMessage();
				break;
			}
			break;

		case MsgBtGotoListButton:
				if(area_status)
					if(area.MoveByList())
						DisplayCurrentMessage();
			break;
			
		case MsgBtcopyButton:
			MsgFormDoCommand(ToolsCopytoarea);
			break;
		case MsgBtTreeButton:
			if(area_status)
				if(area.MoveByTree())
					DisplayCurrentMessage();
			break;
		
		case MsgBtDelButton:
			if(area_status)
			{
				area.DeleteCurrentMessage();
				DisplayCurrentMessage();
			};
			break;
			
		case MsgBtNextReplyButton:
			if(area_status)
				if(area.MoveToNextReply())
					DisplayCurrentMessage();
			break;
			
		case MsgBtPrevReplyButton:
			if(area_status)
				if(area.MoveToPrevReply())
					DisplayCurrentMessage();
			break;
			
		case MsgBtNextButton:
			if(area_status)
				if(area.MoveToNext())
					DisplayCurrentMessage();
			break;
			
		case MsgBtPrevButton:
			if(area_status)
				if(area.MoveToPrev())
					DisplayCurrentMessage();
			break;
		
		case MsgBtCloseButton:
			FrmGotoForm(MainForm);
			break;
		};
		handled=true;
		break;

	default:
		break;
	}
	
	return handled;
}

static Boolean MsgHeaderFormEvent(EventPtr eventP)
{
   Boolean handled=false;
   FormPtr frmP;

	switch (eventP->eType) 
	{
	case keyDownEvent:
		handled=true;
		break;
	
	case frmOpenEvent:
		frmP=FrmGetActiveForm();
		FrmDrawForm(frmP);
		FillMsgHead();
		handled=true;
		break;

	case ctlSelectEvent:
		switch(eventP->data.ctlSelect.controlID)
		{
		case MsgHeaderBtOKButton:
			FrmReturnToForm(0);
			handled=true;
			break;
		};
	default:
		break;
	}
	return handled;
};

static Boolean TosserCFGFormEvent(EventPtr eventP)
{
   Boolean handled=false;
   FormPtr frmP;
   int tmp_selection;

	switch(eventP->eType) 
	{
	case frmOpenEvent:
		frmP=FrmGetActiveForm();
		LstSetSelection((ListType*)GetObjectPtr(TosserCFGTossTypeList),FidoReaderPrefs.TossType);
		CtlSetLabel((ControlType*)GetObjectPtr(TosserCFGUnnamed5004PopTrigger),LstGetSelectionText((ListType*)GetObjectPtr(TosserCFGTossTypeList),FidoReaderPrefs.TossType));
		
		CtlSetValue((ControlType*)GetObjectPtr(TosserCFGAutoRunTosserCheckbox),FidoReaderPrefs.attrAutoRunTosser);
		CtlSetValue((ControlType*)GetObjectPtr(TosserCFGAutoRunPurgerCheckbox),FidoReaderPrefs.attrAutoRunPurger);
		
		FrmDrawForm(frmP);
		
		handled=true;
		break;

	case ctlSelectEvent:
		switch(eventP->data.ctlSelect.controlID)
		{
		case TosserCFGBtTTInfoButton:
			FrmHelp(infoTossTypeString);
			handled=true;
			break;
			
		case TosserCFGBtInfoAutoRunTosserButton:
			FrmHelp(infoAutoRunTosserString);
			handled=true;
			break;
			
		case TosserCFGBtInfoAutoRunPurgerButton:
			FrmHelp(infoAutoRunPurgerString);
			handled=true;
			break;
			

		case TosserCFGBtOKButton:
			tmp_selection=LstGetSelection((ListType*)GetObjectPtr(TosserCFGTossTypeList));
			if(tmp_selection!=-1)
				FidoReaderPrefs.TossType=tmp_selection;
	
			FidoReaderPrefs.attrAutoRunTosser=CtlGetValue((ControlType*)GetObjectPtr(TosserCFGAutoRunTosserCheckbox));
			FidoReaderPrefs.attrAutoRunPurger=CtlGetValue((ControlType*)GetObjectPtr(TosserCFGAutoRunPurgerCheckbox));

			FrmReturnToForm(0);
			break;

		case TosserCFGBtCancelButton:
			FrmReturnToForm(0);
			break;
		};
	default:
		break;
	}
	return handled;
};

static Boolean AreaPrefsFormEvent(EventPtr eventP)
{
   Boolean handled=false;
   FormPtr frmP;
   
	switch(eventP->eType) 
	{
	case frmOpenEvent:
		frmP=FrmGetActiveForm();
		
//		SetFieldText(AreaPrefsFldDelReadDaysField,StrAToI(sah.delreaddays));
//		SetFieldText(AreaPrefsFldDelUnreadDaysField,StrAToI(sah.delunreaddays));
		
		FldSetTextHandle((FieldType*)GetObjectPtr(AreaPrefsFldDelReadDaysField),MemHandleNew(4));
		FldSetTextHandle((FieldType*)GetObjectPtr(AreaPrefsFldDelUnreadDaysField),MemHandleNew(4));
		
		if(CArea::GetAreaHeader(cfdl.GetLocalID(FidoReaderPrefs.SelectedArea),&sah))
		{
			CtlSetValue((ControlType*)GetObjectPtr(AreaPrefsTrDelReadCheckbox),sah.attrdelread);
			CtlSetValue((ControlType*)GetObjectPtr(AreaPrefsTrDelUnreadCheckbox),sah.attrdelunread);
			CtlSetValue((ControlType*)GetObjectPtr(AreaPrefsTrDoBackUpCheckbox),sah.attrdobackup);
			CtlSetValue((ControlType*)GetObjectPtr(AreaPrefsTrCleanEnableCheckbox),sah.attrcleanenable);

			CtlSetValue((ControlType*)GetObjectPtr(AreaPrefsTrApplyAllCheckbox),0);
	
			if(sah.attrdelread)
			{
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsLbdelreadLabel));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsFldDelReadDaysField));
			}
			else
			{
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsLbdelreadLabel));
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsFldDelReadDaysField));
			};
	
			if(sah.attrdelunread)
			{
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsLbdelunreadLabel));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsFldDelUnreadDaysField));
			}
			else
			{
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsLbdelunreadLabel));
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsFldDelUnreadDaysField));
			};
			
			mlSetFieldValue((FieldType*)GetObjectPtr(AreaPrefsFldDelReadDaysField),sah.delreaddays);
			mlSetFieldValue((FieldType*)GetObjectPtr(AreaPrefsFldDelUnreadDaysField),sah.delunreaddays);
		}
		else
			FrmReturnToForm(0);
	
		FrmDrawForm(frmP);
		handled=true;
		break;

	case ctlSelectEvent:
		frmP=FrmGetActiveForm();
		switch(eventP->data.ctlSelect.controlID)
		{
		case AreaPrefsBtInfoDelReadButton:
			FrmHelp(infodelreadString);
			handled=true;
			break;

		case AreaPrefsBtInfoDelUnreadButton:
			FrmHelp(infodelunreadString);
			handled=true;
			break;

		case AreaPrefsBtInfoBackUpButton:
			FrmHelp(infodobackupString);
			handled=true;
			break;
			
		case AreaPrefsBtInfoCleanEnableButton:
			FrmHelp(infoCleanEnableString);
			handled=true;
			break;
	
		case AreaPrefsBt_apply_all_infoButton:
			FrmHelp(infoApplyAllString);
			handled=true;
			break;
	
		case AreaPrefsTrDelReadCheckbox:
			if(CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrDelReadCheckbox)))
			{
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsLbdelreadLabel));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsFldDelReadDaysField));
			}
			else
			{
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsLbdelreadLabel));
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsFldDelReadDaysField));
			};
			break;

		case AreaPrefsTrDelUnreadCheckbox:
			if(CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrDelUnreadCheckbox)))
			{
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsLbdelunreadLabel));
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsFldDelUnreadDaysField));
			}
			else
			{
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsLbdelunreadLabel));
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,AreaPrefsFldDelUnreadDaysField));
			};
			break;

		case AreaPrefsBtOkButton:

			sah.attrdelread=CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrDelReadCheckbox));
			sah.attrdelunread=CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrDelUnreadCheckbox));
			sah.attrdobackup=CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrDoBackUpCheckbox));
			sah.attrcleanenable=CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrCleanEnableCheckbox));
			
			if(!mlGetFieldValue((FieldType*)GetObjectPtr(AreaPrefsFldDelReadDaysField),sah.delreaddays))
				sah.delreaddays=1;
			if(!mlGetFieldValue((FieldType*)GetObjectPtr(AreaPrefsFldDelUnreadDaysField),sah.delunreaddays))
				sah.delunreaddays=2;
			
			if(sah.attrdobackup)
				mlSetDBBackUpAttribute(cfdl.GetLocalID(FidoReaderPrefs.SelectedArea),1);
			else
				mlSetDBBackUpAttribute(cfdl.GetLocalID(FidoReaderPrefs.SelectedArea),0);

			CArea::SetAreaHeader(cfdl.GetLocalID(FidoReaderPrefs.SelectedArea),&sah);

			if(CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrApplyAllCheckbox)))
			{
				SAreaHeader tsah;
				for(int i=0;i<cfdl.GetAreaCount();i++)
				{
					if(i!=FidoReaderPrefs.SelectedArea)
					{
						CArea::GetAreaHeader(cfdl.GetLocalID(i),&tsah);
						
						tsah.attrdelread=CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrDelReadCheckbox));
						tsah.attrdelunread=CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrDelUnreadCheckbox));
						tsah.attrdobackup=CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrDoBackUpCheckbox));
						tsah.attrcleanenable=CtlGetValue((ControlType*)GetObjectPtr(AreaPrefsTrCleanEnableCheckbox));
			
						if(!mlGetFieldValue((FieldType*)GetObjectPtr(AreaPrefsFldDelReadDaysField),tsah.delreaddays))
							tsah.delreaddays=1;
						if(!mlGetFieldValue((FieldType*)GetObjectPtr(AreaPrefsFldDelUnreadDaysField),tsah.delunreaddays))
							tsah.delunreaddays=2;
			
						if(tsah.attrdobackup)
							mlSetDBBackUpAttribute(cfdl.GetLocalID(i),1);
						else
							mlSetDBBackUpAttribute(cfdl.GetLocalID(i),0);

						CArea::SetAreaHeader(cfdl.GetLocalID(i),&tsah);
					}
				}
			}

			FrmReturnToForm(0);
			break;

		case AreaPrefsBtCancelButton:
			FrmReturnToForm(0);
			break;
		};
	default:
		break;
	}
	return handled;
};


static Boolean AppHandleEvent(EventPtr eventP)
{
	UInt16 formId;
	FormPtr frmP;

	if (eventP->eType==frmLoadEvent)
	{
		formId=eventP->data.frmLoad.formID;
		frmP=FrmInitForm(formId);
		FrmSetActiveForm(frmP);

		switch (formId)
		{
		case MainForm:
			FrmSetEventHandler(frmP,MainFormHandleEvent);
			break;

		case MsgForm:
			FrmSetEventHandler(frmP,MsgFormHandleEvent);
			break;

		case MsgHeaderForm:
			FrmSetEventHandler(frmP,MsgHeaderFormEvent);
			break;
			
		case AreaPrefsForm:
			FrmSetEventHandler(frmP,AreaPrefsFormEvent);
			break;
			
		case TosserCFGForm:
			FrmSetEventHandler(frmP,TosserCFGFormEvent);
			break;
			
		default:
//			ErrFatalDisplay("Invalid Form Load Event");
			break;
		}
		return true;
	}
	return false;
}

static UInt32 last_tick_count=0;

static void AppEventLoop(void)
{
	UInt16 error;
	EventType event;

	do
	{
		KeySetMask(KEY_ALL_ENABLE);
		EvtGetEvent(&event,evtWaitForever);

		if(event.eType==keyDownEvent)
			last_key_status=KeyCurrentState();

		KeySetMask(KEY_NEED_ENABLE);
		
		
		if(event.eType==keyDownEvent /*&& area_status && msg_status*/ && (last_key_status&(8|16|32|64)))
		{
/*			if(TimGetTicks()-last_tick_count>SysTicksPerSecond()>>4)
				SysTaskDelay(SysTicksPerSecond()>>2);
			else
				SysTaskDelay(SysTicksPerSecond()>>5);

			last_tick_count=TimGetTicks();*/

			if(!MenuHandleEvent(0,&event,&error))
				if(!AppHandleEvent(&event))
					FrmDispatchEvent(&event);
		}
		else
		{
			if(!SysHandleEvent(&event))
				if(!MenuHandleEvent(0,&event,&error))
					if(!AppHandleEvent(&event))
						FrmDispatchEvent(&event);
		};

	#if EMULATION_LEVEL != EMULATION_NONE
		ECApptDBValidate (ApptDB);
	#endif

	}
	while(event.eType!=appStopEvent);
}

static Err AppStart(void)
{
//	SPreferenceType prefs;

   UInt16 prefsSize;

	FtrGet(sysFtrCreator,sysFtrNumROMVersion,&curromVersion);

	prefsSize=sizeof(SPreferenceType);
	if(PrefGetAppPreferences(appFileCreator,appPrefID,&FidoReaderPrefs,&prefsSize,true)==noPreferenceFound)
	{
		FidoReaderPrefs.TossType=1;
		FidoReaderPrefs.SelectedArea=0;
		FidoReaderPrefs.CurrentFontID=stdFont;
		FidoReaderPrefs.CardNum=0;
		FidoReaderPrefs.attrAutoRunTosser=0;
		FidoReaderPrefs.attrAutoRunPurger=0;
	}
	if(FidoReaderPrefs.attrAutoRunTosser)
		DoToss(1);
		
	if(mlIsDBPresent(FidoReaderPrefs.fontdbid))
	{
		fontdbref=DmOpenDatabase(0,FidoReaderPrefs.fontdbid,dmModeReadOnly);
		fonth=DmGetRecord(fontdbref,0);
		fontp=(FontPtr)MemHandleLock(fonth);
		FntDefineFont((FontID)130,fontp);
	}
	else
	{
		if(FidoReaderPrefs.CurrentFontID>128)
			FidoReaderPrefs.CurrentFontID=stdFont;
			
		fonth=0;
	}
	
	StrCopy(last_search_string,"-=[search string]=-");

   return errNone;
}

static void AppStop(void)
{
	SaveAndCloseArea();

	if(FidoReaderPrefs.attrAutoRunPurger)
		DoPurge();

	PrefSetAppPreferences(appFileCreator,appPrefID,appPrefVersionNum,&FidoReaderPrefs,sizeof(SPreferenceType),true);

	cfdl.Free();
	
	if(fonth)
	{	
		MemHandleUnlock(fonth);
		fonth=0;
		DmReleaseRecord(fontdbref,0,true);	
		DmCloseDatabase(fontdbref);
	};
	
	
	FrmCloseAllForms();
}

static UInt32 StarterPalmMain(UInt16 cmd,MemPtr cmdPBP,UInt16 launchFlags)
{
	Err error;

	error=RomVersionCompatible(ourMinVersion,launchFlags);
	if(error)
		return (error);

	FindParamsType *fpt;
	
	
	switch(cmd)
	{
	case sysAppLaunchCmdFind:
		fpt=(FindParamsType*)cmdPBP;
		
		FindDrawHeader(fpt,"Fido Reader");
		error=0;
		return 0;
		
//	case sysAppLaunchCmdGoto:
//		return 0;
	case sysAppLaunchCmdNormalLaunch:
		error=AppStart();
		if(error) 
			return error;
				
		FrmGotoForm(MainForm);
		AppEventLoop();
		AppStop();
		break;

	default:
		break;
	}
	return errNone;
}

UInt32 PilotMain(UInt16 cmd,MemPtr cmdPBP,UInt16 launchFlags)
{

    return StarterPalmMain(cmd,cmdPBP,launchFlags);
}

